#define NDEBUG
#include <math.h>
#include <assert.h>
#include "factor.h"

unsigned int multiplyFactors( const unsigned int* factors , size_t count )
{
  printf( "[DEBUG] Testing factors\n" );
  unsigned int product = 1;
  for( int i=0 ; i<count ; i++ ) product *= factors[i];
  return product;
}

int factor( unsigned int n , unsigned int* factors , size_t maxFactors )
{
  if( n==0 ) return -1;
  if( n==1 ) return 0;
  if( maxFactors==0 ) return -1;
  int maxFactor = (int)( sqrt(n) );
  int f;
  for( f=2 ; f<=(int)maxFactor ; f++ )
  {
    if( n==((n/f)*f) )
    {
      int found1 = factor( f , factors , maxFactors );
      if( found1==-1 ) return -1;
      int found2 = factor( n/f , factors + found1 , maxFactors-found1 );
      if( found2==-1 ) return -1;
      assert( n==multiplyFactors( factors , found1+found2 ) );
      return found1 + found2;
    }
  }
  factors[0] = n;
  return 1;
}
